// -*- coding: utf-8 -*-

// Copyright (C) 2013 Stefan Besler <melongex@gmail.com>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

import QtQuick 1.0
import org.kde.plasma.components 0.1 as PlasmaComponents
import org.kde.plasma.graphicswidgets 0.1 as PlasmaWidgets
import org.kde.plasma.core 0.1 as PlasmaCore
//import "plasmapackage:/code/dotastat.js" as DS

Rectangle {
    property int minimumWidth: 100
    property int minimumHeight: 20

    id: wrapper
    color: "transparent"
    property string isActivePath: "qdbus org.kde.kwin /KWin compositingActive";

    Component.onCompleted: {
        plasmoid.immutable = true;
    }

    PlasmaCore.DataSource {
        id: isActiveSource
        engine: "executable"
        connectedSources: isActivePath

        // Alle paar Minuten checken wir den aktuellen Status (Polling)
        interval: 1000 * 60 * 5

        onNewData: {
            console.log("New data from: " + sourceName);
            var isCompositing = data["stdout"].trim();
            console.log(isActivePath + " --> "+isCompositing)

            checkbox.checked = isCompositing === "false";
        }
    }

    PlasmaCore.DataSource {
        id: toggleSource
        engine: "executable"
    }

    PlasmaComponents.CheckBox {
        id: checkbox
        text: "Gamemode"
        width: parent.width - 10
        height: parent.height
        y: 0
        x: 5

        onClicked: {
            var executablePath = "qdbus org.kde.kwin /KWin toggleCompositing";
            toggleSource.connectSource(executablePath);
            toggleSource.removeSource(executablePath);

            if(checked)
            {
                console.log("Gamemode -> on");
            }
            else
            {
                console.log("Gamemode -> off");
            }
        }
    }
}

